unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, REST.Types, REST.Client,
  Data.Bind.Components, Data.Bind.ObjectScope, Vcl.StdCtrls;

type
  TfrmMain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RESTClient1: TRESTClient;
    RESTRequest1: TRESTRequest;
    RESTResponse1: TRESTResponse;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RESTRequest1AfterExecute(Sender: TCustomRESTRequest);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  ModalMap;

{$R *.dfm}

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  if not Assigned(frmMap) then
    frmMap := TfrmMap.Create(nil);

  try
    frmMap.ShowModal;
  finally
    FreeAndNil(frmMap);
  end;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  RESTRequest1.Resource := '/json_test';
  RESTRequest1.Execute;
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.RESTRequest1AfterExecute(Sender: TCustomRESTRequest);
begin
  MessageDlg('The first 50 characters of the JSON response are:' + #13 +
             Copy((RESTResponse1.JSONValue).ToString, 1, 50),
             mtInformation, [mbOK], 0);
end;

end.
